package simulatie;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.Observable;
import java.util.Random;

import spelers.abstracts.AbstractBurger;
import spelers.abstracts.AbstractOnschuldigMeisje;
import spelers.abstracts.AbstractSpeler;
import spelers.abstracts.AbstractWeerwolf;
import spelers.abstracts.AbstractZiener;
import spelers.derdeOrde.DrieBurger;
import spelers.derdeOrde.DrieOnschuldigMeisje;
import spelers.derdeOrde.DrieWeerwolf;
import spelers.derdeOrde.DrieZiener;
import spelers.eersteOrde.EenBurger;
import spelers.eersteOrde.EenOnschuldigMeisje;
import spelers.eersteOrde.EenWeerwolf;
import spelers.eersteOrde.EenZiener;
import spelers.nuldeOrde.NulBurger;
import spelers.nuldeOrde.NulOnschuldigMeisje;
import spelers.nuldeOrde.NulWeerwolf;
import spelers.nuldeOrde.NulZiener;
import spelers.tweedeOrde.TweeBurger;
import spelers.tweedeOrde.TweeOnschuldigMeisje;
import spelers.tweedeOrde.TweeWeerwolf;
import spelers.tweedeOrde.TweeZiener;


public class Model extends Observable{
	public ArrayList<AbstractSpeler> spelers = new ArrayList<AbstractSpeler>();
	public ArrayList<AbstractWeerwolf> weerwolven = new ArrayList<AbstractWeerwolf>();
	public ArrayList<AbstractBurger> burgers = new ArrayList<AbstractBurger>();
	private ArrayList<AbstractZiener> zieners = new ArrayList<AbstractZiener>();
	private ArrayList<AbstractOnschuldigMeisje> onschuldigeMeisjes = new ArrayList<AbstractOnschuldigMeisje>();
	
	public ArrayList<Integer> stemmen = new ArrayList<Integer>();
	public int[] laatsteBrandstapelStemgedrag;
	
	List<String> namenLijst = new ArrayList<String>(Arrays.asList(new String[] {
			"Lebron James", "Kobe Bryant", "Steven Nash", "Austin Powers", "Chris Paul",
	        "Arjen Robben", "James Bond", "Robin van Persie", "Marco van Basten",
	        "Edwin van der Sar", "Eric Cartman", "Meg Griffin", "Spongebob Squarepants","Mark Rutte",
	        "Nat King Cole", "Tyra Banks", "Hermione Granger", "Bob Ross", "Arnold Schwarzenegger",
	        "Waldo"}));
	
	private static Random r = new Random();
	private int aantalWeerwolven = 3;
	private int aantalBurgers = 4;
	private int aantalZieners = 2;
	private int aantalOnschuldigeMeisjes = 1;
	
	private int aantalRollen = 4;
	private int aantalInitSpelers = 0;
	
	public Model(){
	    initSpelers();
	    laatsteBrandstapelStemgedrag = new int[this.geefAantalSpelers()];
	}

	private void initSpelers() {
		for (int i = 0; i < aantalWeerwolven; i ++){
			AbstractWeerwolf weerwolf = new TweeWeerwolf(this, namenLijst.remove(r.nextInt(namenLijst.size())),aantalInitSpelers);
			weerwolven.add(weerwolf);
			spelers.add(weerwolf);
			aantalInitSpelers ++;
		}
		
		for (int i = 0; i < aantalBurgers; i ++){
			AbstractBurger burger = new DrieBurger(this, namenLijst.remove(r.nextInt(namenLijst.size())),aantalInitSpelers);
			burgers.add(burger);
			spelers.add(burger);
			aantalInitSpelers ++;
		}
		
		for (int i = 0; i < aantalZieners; i ++){
			AbstractZiener ziener = new DrieZiener(this, namenLijst.remove(r.nextInt(namenLijst.size())),aantalInitSpelers);
			zieners.add(ziener);
			burgers.add(ziener);
			spelers.add(ziener);
			aantalInitSpelers ++;
		}
		
		for (int i = 0; i < aantalOnschuldigeMeisjes; i ++){
			AbstractOnschuldigMeisje onschuldigMeisje = new DrieOnschuldigMeisje(this, namenLijst.remove(r.nextInt(namenLijst.size())),aantalInitSpelers);
			onschuldigeMeisjes.add(onschuldigMeisje);
			burgers.add(onschuldigMeisje);
			spelers.add(onschuldigMeisje);
			aantalInitSpelers ++;
		}
	}
	
	public String eetSpelerOpEnGeefNaamTerug(int id){
		Iterator<AbstractSpeler> it = spelers.iterator();
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			if (itSpeler.id == id){
				itSpeler.inLeven = false;
				return itSpeler.naam;
			}
		}
		System.out.println("model.eetSpelerOpEnGeefNaamTerug(int id): Geen speler gevonden met die ID");
		return "Geen speler gevonden met die ID";
	}
	
	public String verbrandSpelerEnGeefNaamTerug(int id){
		Iterator<AbstractSpeler> it = spelers.iterator();
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			if (itSpeler.id == id){
				itSpeler.inLeven = false;
				return itSpeler.naam;
			}
		}
		System.out.println("model.eetSpelerOpEnGeefNaamTerug(int id): Geen speler gevonden met die ID");
		return "Geen speler gevonden met die ID";
	}
	
	public void initAlleInschattingen() {
		Iterator<AbstractSpeler> it = spelers.iterator();
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			if (itSpeler.inLeven == true){
				itSpeler.initAndereSpelerInschattingen();
			}
		}
	}
	
	public void updateAlleInschattingen() {
		Iterator<AbstractSpeler> it = spelers.iterator();
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			if (itSpeler.inLeven == true){
				itSpeler.updateAndereSpelerInschattingen();
			}
		}
	}
	
	public int weerwolvenOpEetStemID(){
		Iterator<AbstractWeerwolf> it = weerwolven.iterator();
		int[] stemmen = new int[spelers.size()];
		while (it.hasNext()) {
			AbstractWeerwolf itWeerwolf = (AbstractWeerwolf) it.next();
			if (itWeerwolf.inLeven == true){				
				stemmen[itWeerwolf.opEetBurgerID()] ++;
			}
		}
		
		return geefMaxIndex(stemmen);
	}

	public int brandstapelStemID(){
		Iterator<AbstractSpeler> it = spelers.iterator();
		int[] stemmen = new int[spelers.size()];
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			if (itSpeler.inLeven == true){
				int stem = itSpeler.stemVerbrandenID();
//				System.out.println(itSpeler.naam + " stemt op " + spelers.get(stem).naam);
				stemmen[stem] ++;
				laatsteBrandstapelStemgedrag[itSpeler.id]=stem;
			}
			else {
				//Bij een dode speler wordt de stem op -1 gezet. Hiermee wordt verder niets gedaan.
				laatsteBrandstapelStemgedrag[itSpeler.id]=-1;
			}
		}
		
//		for (int i = 0; i < stemmen.length; i++){
//			System.out.println("Stemmen op ID " + i + ": " + stemmen[i]);
//		}
		
		return geefMaxIndex(stemmen);
	}

	
	public int geefAantalWeerwolven() {
		return aantalWeerwolven;
	}

	public int geefAantalBurgers() {
		return aantalBurgers;
	}

	public int geefAantalZieners() {
		return aantalZieners;
	}
	
	public int geefAantalOnschuldigeMeisjes() {
		return aantalOnschuldigeMeisjes;
	}

	public int geefAantalSpelers(){
		return aantalWeerwolven + aantalBurgers + aantalZieners + aantalOnschuldigeMeisjes;
	}
	
	public int geefAantalRollen() {
		return aantalRollen;
	}


	public int geefMaxWaarde(int[] intLijst){
		int max = intLijst[0];
		for (int i = 0; i < intLijst.length; i++) {
			if (intLijst[i] > max) {
				max = intLijst[i];
			}

		}
		return max;
	}
	
	//maakt een lijst van indexxen die de maximale waarde bevatten, en kiest hieruit een random index
	public int geefMaxIndex(int[] intLijst){
		int max = -1;

		ArrayList<Integer> maxIDs = new ArrayList<Integer>();
		for (int i = 0; i < intLijst.length; i++) {
			//nieuw maximum, clear lijst en voeg index toe
			if (intLijst[i] > max) {
				max = intLijst[i];
				maxIDs.clear();
				maxIDs.add(i);
			}
			else {
				//zelfde maximum als vorige, voeg index toe bij eerder indexen
				if (intLijst[i] == max) {
					maxIDs.add(i);
				}
			}
		}
		return maxIDs.get(r.nextInt(maxIDs.size()));
	}
	
	public boolean weerwolvenGewonnen(){
		Iterator<AbstractBurger> it = burgers.iterator();
		while (it.hasNext()) {
			AbstractBurger itBurger = (AbstractBurger) it.next();
			if (itBurger.inLeven == true){
				return false;
			}
		}
		return true;
	}
	
	public boolean burgersGewonnen(){
		Iterator<AbstractWeerwolf> it = weerwolven.iterator();
		while (it.hasNext()) {
			AbstractWeerwolf itWeerwolf = (AbstractWeerwolf) it.next();
			if (itWeerwolf.inLeven == true){
				return false;
			}
		}
		return true;
	}

	public void zienersZienKaart() {
		Iterator<AbstractZiener> it = zieners.iterator();
		while (it.hasNext()) {
			AbstractZiener itZiener= (AbstractZiener) it.next();
			if (itZiener.inLeven == true){
				itZiener.kijkNaarKaart();
			}
		}
		
	}
}
