package simulatie;

import java.util.Iterator;
import java.util.Random;
import java.util.Scanner;

import spelers.abstracts.AbstractSpeler;

public class Simulatie {
	private static Random r = new Random();
	static boolean keyPress = true;
	static Model model;
	static boolean simuleerDuizendKeer = false;
	static int aantalWeerwolvenGewonnen =0;
	static int aantalBurgersGewonnen =0;
	static String format = "%-35s%-38s%s%n";

	public static void main(String[] args) {
		if (simuleerDuizendKeer){
			keyPress = false;
			startDuizendKeerSimulatie();
		}			
		else{
			startSpel();
		}
	}
	
	public static void startDuizendKeerSimulatie(){
		for (int i =0; i <1000; i++){
			startSpel();
		}
		System.out.println("");
		System.out.println("");
		System.out.println("Eindscore na 1000 simulaties");
		System.out.println("Aantal weerwolf-overwinningen: " + aantalWeerwolvenGewonnen);
		System.out.println("Aantal burger-overwinningen: " + aantalBurgersGewonnen);
	}	
	
	
	
	public static void startSpel(){
		model = new Model();
		geefBeginBoodschap();
		model.initAlleInschattingen();
		for(int beurt = 1; true; beurt ++){
			wachtOpEnter();
			if (volgendeBeurt(beurt)){
				return;
			}
			model.updateAlleInschattingen();
		}
	}
	
	private static void geefBeginBoodschap() {
		System.out.println("Nieuw potje!");
		System.out.println();
		System.out.println("Totaal aantal spelers: " + model.geefAantalSpelers());
		System.out.println("Aantal burgers: " + model.geefAantalBurgers());
		System.out.println("Aantal zieners: " + model.geefAantalZieners());
		System.out.println("Aantal weerwolven: " + model.geefAantalWeerwolven());
		System.out.println("Aantal onschuldige meisjes: " + model.geefAantalOnschuldigeMeisjes());
		
		printAlleSpelers();
	}

	public static boolean volgendeBeurt(int beurt) {
		System.out.println();
		System.out.println("_________________________________________________________________________________________");
		System.out.println("Beurt: " + beurt);
		printAlleSpelers();
		if (volgendeNacht())
			return true;
		if (volgendeDag()){
			return true;
		}
		model.updateAlleInschattingen();
		return false;
	}
	
	
	//weerwolven stemmen welke burger ze willen opeten en doen dat vervolgenss
	private static boolean volgendeNacht() {
		if (checkSpelAfgelopen()){
			return true;
		}
		System.out.println();
		System.out.println("Nacht! Etenstijd.");
		
		model.zienersZienKaart();
		
		int keuzeOmOpTeEten = model.weerwolvenOpEetStemID();
		AbstractSpeler opgegetenSpeler = model.spelers.get(keuzeOmOpTeEten);
		model.eetSpelerOpEnGeefNaamTerug(keuzeOmOpTeEten);
		System.out.println(opgegetenSpeler.rol + " " + opgegetenSpeler.naam + " is zojuist opgegeten door de weerwolven.");
		return false;
	}
	
	
	
	private static boolean volgendeDag() {
		if (checkSpelAfgelopen()){
			return true;
		}
//		printAlleSpelers();
		System.out.println();
		System.out.println("Dag! Brandstapeltijd.");
		
		int keuzeOmTeVerbranden = model.brandstapelStemID();
		AbstractSpeler verbrandeSpeler = model.spelers.get(keuzeOmTeVerbranden);
		model.verbrandSpelerEnGeefNaamTerug(keuzeOmTeVerbranden);
		System.out.println(verbrandeSpeler.rol + " " + verbrandeSpeler.naam + " is zojuist verbrand door de spelers.");
		return false;
	}

	public static void wachtOpEnter() {
		if(keyPress){
			Scanner sc = new Scanner(System.in);
       		while(!sc.nextLine().equals(""));
		}
	}
	
	public static void printAlleSpelers() {
		System.out.println("");
		System.out.println("Alle spelers in het spel:");
		Iterator<AbstractSpeler> it = model.spelers.iterator();
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			System.out.printf(format, "Speler: " + itSpeler.naam +" ("+itSpeler.id+")"+".", " Rol: " 
					+ itSpeler.rol+" ("+itSpeler.orde+ ").", " Leeft: " + itSpeler.inLeven +".");
		}
	}
	
	public static void printAlleLevendeSpelers() {
		System.out.println("");
		System.out.println("Alle levende spelers in het spel:");
		Iterator<AbstractSpeler> it = model.spelers.iterator();
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			if (itSpeler.inLeven){
				System.out.printf(format, "Speler: " + itSpeler.naam +" ("+itSpeler.id+")"+".", " Rol: " + 
						itSpeler.rol+" ("+itSpeler.orde+ ").", " Leeft: " + itSpeler.inLeven +".");
			}
		}
	}
	
	
	public static boolean checkSpelAfgelopen(){
		if (model.weerwolvenGewonnen()){
			System.out.println("Weerwolven hebben gewonnen!");
			aantalWeerwolvenGewonnen ++;
			return true;
		}
		
		if (model.burgersGewonnen()){
			System.out.println("Burgers hebben gewonnen!");
			aantalBurgersGewonnen ++;
			return true;
		}
		return false;
	}
}