package spelers.abstracts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;

import simulatie.Model;


public abstract class AbstractSpeler {
    protected static Random r = new Random();
    protected Model model;
    public int id;
	public String naam;
	public boolean inLeven = true;
	public String rol;
	public String orde;
	public ArrayList<String> andereSpelerInschattingen = new ArrayList<String>();
    
	
	public String burgerOfZienerOfOM = "Burger, ziener of onschuldig meisje";
	public String burgerOfZiener = "Burger of ziener";
	public String zekerZiener = "Ziener";
	public String zekerOM = "Onschuldig meisje";
	public String zekerBurger = "Burger";
	public String zekerWolf = "Weerwolf";
	public String onbekendeRol = "Weerwolf, burger, ziener of onschuldig meisje";
	public String verhoogdRisicoOpZienerOfOM = "Burger, verhoogd risico op ziener/onschuldig meisje";	
	public String verhoogdRisicoOpZiener = "Burger, verhoogd risico op ziener";
	
	//1e order burgers
	public String verhoogdRisicoOpWeerwolf = "Verhoogd risico op weerwolf";
	public String verhoogdRisicoOpBurger = "Verhoogde kans op burger";
	
	//ordes
	public String nuldeOrde = "Nulde orde";
	public String eersteOrde = "Eerste orde";
	public String tweedeOrde = "Tweede orde";
	public String derdeOrde = "Derde orde";
	
    protected int aantalSpelers;
    protected int aantalBurgers;
    protected int aantalWeerwolven;
    protected int aantalZieners;
    protected int aantalRollen;
    
    //Elke speler krijg een referentie mee naar het model zodat ook die methodes beschikbaar zijn
    public AbstractSpeler(Model controller, String naam, int id) { 
		this.model = controller;
		this.naam = naam;
		this.id = id;
		
		aantalBurgers = model.geefAantalBurgers();
	    aantalWeerwolven = model.geefAantalWeerwolven();
	    aantalZieners = model.geefAantalZieners();
	    aantalRollen = model.geefAantalRollen();
	    aantalSpelers = model.geefAantalSpelers();	    
	}
    
    public abstract void updateAndereSpelerInschattingen();
    
    public abstract void initAndereSpelerInschattingen();
    
	public String geefNaam() {
		return naam;
	}

	public void instellenNaam(String naam) {
		this.naam = naam;
	}
	
	public abstract int stemVerbrandenID();
	
}
