package spelers.derdeOrde;

import java.util.Iterator;

import simulatie.Model;
import spelers.abstracts.AbstractBurger;
import spelers.abstracts.AbstractSpeler;

public class DrieBurger extends AbstractBurger{

	public DrieBurger(Model controller, String naam, int id) {
		super(controller, naam, id);
		this.orde = derdeOrde;
	}

	@Override
	//Probeer uit te zoeken welke spelers waarschijnlijk weerwolf/burger zijn
	public void updateAndereSpelerInschattingen() {
		Iterator<AbstractSpeler> it = model.spelers.iterator();
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			if (itSpeler.inLeven == true){
				int spelersStem = model.laatsteBrandstapelStemgedrag[itSpeler.id];
				//Als een speler de vorige keer op een weerwolf heeft gestemd, kan het elke rol zijn, aangezien weerwolven
				//soms ook op andere weerwolven stemmen
				if (model.spelers.get(spelersStem).rol.equals("Weerwolf")){
					andereSpelerInschattingen.set(itSpeler.id, onbekendeRol);
				}
				//Weerwolven zullen meestal nog altijd op burgers stemmen
				//Ook het onschuldig meisje stemt soms op een burger, maar slechts zeer zelden,
				//dus dat is een aanvaardbaar risico
				else{
					andereSpelerInschattingen.set(itSpeler.id, verhoogdRisicoOpWeerwolf);
				}

			}
		}
		//van zichzelf weten ze nog wel wat ze zijn, ook al hebben ze zelf verkeerd gestemd.
		andereSpelerInschattingen.set(this.id, this.rol);
	}

}
