package spelers.derdeOrde;

import java.util.ArrayList;
import java.util.Iterator;

import simulatie.Model;
import spelers.abstracts.AbstractBurger;
import spelers.abstracts.AbstractOnschuldigMeisje;
import spelers.abstracts.AbstractSpeler;

public class DrieOnschuldigMeisje extends AbstractOnschuldigMeisje{

	public DrieOnschuldigMeisje(Model controller, String naam, int id) {
		super(controller, naam, id);
		this.orde = derdeOrde;
	}
	
	
	//Een derde orde onschuldig meisje stemt af en toe op een burger om de weerwolven te misleiden,
	//net zoals een derde order onschuldig meisje
	
	@Override
	//Volgorde van stemmen voor burgers:
	//1. zekerWolf
	//2. verhoogdRisicoOpWeerwolf
	//3. onbekendeRol
	//4. rest
	
	public int stemVerbrandenID() {
		if (r.nextInt(100)<20){
			AbstractBurger verbrandStem = model.burgers.get(r.nextInt(model.burgers.size()));
			System.out.println("Om de weerwolven te misleiden stemt " + this.rol + " " + this.naam +
					" op " + verbrandStem.rol + " " + verbrandStem.naam +".");
			return verbrandStem.id;
		}
		
		Iterator<AbstractSpeler> it = model.spelers.iterator();
		ArrayList<Integer> kandidaten = new ArrayList<Integer>();
		
		//1. Check eerst op "zekerWolf", aangezien burgers weerwolven willen verbranden
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			if (itSpeler.inLeven == true & 
					andereSpelerInschattingen.get(itSpeler.id).equals(zekerWolf)){
				kandidaten.add(itSpeler.id);
			}
		}
		
		if (kandidaten.size()>0){
			int keuzeVerbrandStem = kandidaten.get(r.nextInt(kandidaten.size()));
			
			System.out.println(this.rol +" "+ this.naam + " weet vanwege kaart kijken/spieken zeker dat " + 
					model.spelers.get(keuzeVerbrandStem).naam + " een weerwolf is, "+ 
					"dus wil daarom deze persoon verbranden.");
			return keuzeVerbrandStem;
		}
				
		//2. Check dan op "Verhoogd risico op weerwolf", aangezien burgers vermoedelijke weerwolven willen verbranden		
		kandidaten.clear();
		it = model.spelers.iterator();
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			if (itSpeler.inLeven == true & 
					andereSpelerInschattingen.get(itSpeler.id).equals(verhoogdRisicoOpWeerwolf)){
				kandidaten.add(itSpeler.id);
			}
		}
		
		if (kandidaten.size()>0){
			int keuzeVerbrandStem = kandidaten.get(r.nextInt(kandidaten.size()));
			
			System.out.println(this.rol +" "+ this.naam + " vermoedt op basis van zijn/haar stemgedrag dat " + 
					model.spelers.get(keuzeVerbrandStem).naam + " een weerwolf is, "+ 
					"dus wil daarom deze persoon verbranden.");
			return keuzeVerbrandStem;
		}
		
		kandidaten.clear();
		
		
		//3. en 4.: Bij geen kennis, doe wat willekeurig: kies een willekeurige levende speler
		it = model.spelers.iterator();
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			if (itSpeler.inLeven == true ){
				kandidaten.add(itSpeler.id);
			}
		}
		
		int keuzeVerbrandStem = kandidaten.get(r.nextInt(kandidaten.size()));

		System.out.println(this.rol +" "+ this.naam + " heeft (nog) geen kennis over wie mogelijk  "
				+ "een weerwolf is, dus wil daarom de willekeurige persoon " + model.spelers.get(keuzeVerbrandStem).naam + 
				" verbranden.");

		return keuzeVerbrandStem;
	}
}
