package spelers.derdeOrde;

import java.util.ArrayList;
import java.util.Iterator;

import simulatie.Model;
import spelers.abstracts.AbstractBurger;
import spelers.abstracts.AbstractWeerwolf;

public class DrieWeerwolf extends AbstractWeerwolf{

	public DrieWeerwolf(Model controller, String naam, int id) {
		super(controller, naam, id);
		this.orde = derdeOrde;
	}

	@Override
	public int opEetBurgerID() {
		Iterator<AbstractBurger> it = model.burgers.iterator();
		ArrayList<Integer> kandidaten = new ArrayList<Integer>();
		//Check eerst op "Mogelijk onschuldig meisje/ziener", die hebben prioriteit
		while (it.hasNext()) {
			AbstractBurger itBurger = (AbstractBurger) it.next();
			if (itBurger.inLeven == true & 
					andereSpelerInschattingen.get(itBurger.id).equals(verhoogdRisicoOpZienerOfOM)){
				kandidaten.add(itBurger.id);
			}
		}
		
		if (kandidaten.size()>0){
			int keuzeOpeetStemIndex = r.nextInt(kandidaten.size());
			int keuzeOpeetStem = kandidaten.get(keuzeOpeetStemIndex);
			
			System.out.println(this.rol +" "+ this.naam + " vermoedt op basis van zijn/haar stemgedrag dat " + 
					model.spelers.get(keuzeOpeetStem).naam + " een ziener of zelfs onschuldig meisje is, "+ 
					"dus wil daarom deze persoon opeten.");
			return keuzeOpeetStem;
		}
		
		//Bij geen vermoedelijk onschuldig meisje, eet een vermoedelijke ziener.
		kandidaten.clear();
		
		it = model.burgers.iterator();
		
		while (it.hasNext()) {
			AbstractBurger itBurger = (AbstractBurger) it.next();
			if (itBurger.inLeven == true & 
					andereSpelerInschattingen.get(itBurger.id).equals(verhoogdRisicoOpZiener)){
				kandidaten.add(itBurger.id);
			}
		}
		
		if (kandidaten.size()>0){
			int keuzeOpeetStemIndex = r.nextInt(kandidaten.size());
			int keuzeOpeetStem = kandidaten.get(keuzeOpeetStemIndex);
			
			System.out.println(this.rol +" "+ this.naam + " vermoedt op basis van zijn/haar stemgedrag dat " + 
					model.spelers.get(keuzeOpeetStem).naam + " een ziener is, "+ 
					"dus wil daarom deze persoon opeten.");
			return keuzeOpeetStem;
		}
		
		//Bij geen vermoedelijk onschuldig meisje of ziener, eet een willekeurige burger.
		kandidaten.clear();
		
		for (int s =0; s < model.geefAantalSpelers(); s++){
    		if (andereSpelerInschattingen.get(s).equals(burgerOfZienerOfOM) | andereSpelerInschattingen.get(s).equals(burgerOfZiener)
    				& model.spelers.get(s).inLeven == true){
    			kandidaten.add(model.spelers.get(s).id);
    		}
    	}
		int keuzeOpeetStemIndex = r.nextInt(kandidaten.size());
		int keuzeOpeetStem = kandidaten.get(keuzeOpeetStemIndex);

		System.out.println(this.rol +" "+ this.naam + " heeft (nog) geen kennis over wie mogelijk een onschuldig "
				+ "meisje/ziener is, dus wil daarom de willekeurige persoon " + model.spelers.get(keuzeOpeetStem).naam + 
				" opeten.");

		return keuzeOpeetStem;
	}

	@Override
	public int stemVerbrandenID() {
		if (r.nextInt(100)<20){
			AbstractWeerwolf verbrandStem = model.weerwolven.get(r.nextInt(model.weerwolven.size()));
			System.out.println("Om de burgers te misleiden stemt " + this.rol + " " + this.naam +
					" op " + verbrandStem.rol + " " + verbrandStem.naam +".");
			return verbrandStem.id;
		}
		
		Iterator<AbstractBurger> it = model.burgers.iterator();
		ArrayList<Integer> kandidaten = new ArrayList<Integer>();
		//Check eerst op "Mogelijk onschuldig meisje/ziener", die hebben prioriteit
		while (it.hasNext()) {
			AbstractBurger itBurger = (AbstractBurger) it.next();
			if (itBurger.inLeven == true & 
					andereSpelerInschattingen.get(itBurger.id).equals(verhoogdRisicoOpZienerOfOM)){
				kandidaten.add(itBurger.id);
			}
		}
		
		if (kandidaten.size()>0){
			int keuzeOpeetStemIndex = r.nextInt(kandidaten.size());
			int keuzeOpeetStem = kandidaten.get(keuzeOpeetStemIndex);
			
			System.out.println(this.rol +" "+ this.naam + " vermoedt op basis van zijn/haar stemgedrag dat " + 
					model.spelers.get(keuzeOpeetStem).naam + " een ziener of zelfs onschuldig meisje is, "+ 
					"dus wil daarom deze persoon verbranden.");
			return keuzeOpeetStem;
		}
		
		//Bij geen vermoedelijk onschuldig meisje, eet een vermoedelijke ziener.
		kandidaten.clear();
		
		it = model.burgers.iterator();
		
		while (it.hasNext()) {
			AbstractBurger itBurger = (AbstractBurger) it.next();
			if (itBurger.inLeven == true & 
					andereSpelerInschattingen.get(itBurger.id).equals(verhoogdRisicoOpZiener)){
				kandidaten.add(itBurger.id);
			}
		}
		
		if (kandidaten.size()>0){
			int keuzeOpeetStemIndex = r.nextInt(kandidaten.size());
			int keuzeOpeetStem = kandidaten.get(keuzeOpeetStemIndex);
			
			System.out.println(this.rol +" "+ this.naam + " vermoedt op basis van zijn/haar stemgedrag dat " + 
					model.spelers.get(keuzeOpeetStem).naam + " een ziener is, "+ 
					"dus wil daarom deze persoon verbranden.");
			return keuzeOpeetStem;
		}
		
		//Bij geen vermoedelijk onschuldig meisje of ziener, eet een willekeurige burger.
		kandidaten.clear();
		
		for (int s =0; s < model.geefAantalSpelers(); s++){
    		if (andereSpelerInschattingen.get(s).equals(burgerOfZienerOfOM) | andereSpelerInschattingen.get(s).equals(burgerOfZiener)
    				& model.spelers.get(s).inLeven == true){
    			kandidaten.add(model.spelers.get(s).id);
    		}
    	}
		int keuzeOpeetStemIndex = r.nextInt(kandidaten.size());
		int keuzeOpeetStem = kandidaten.get(keuzeOpeetStemIndex);

		System.out.println(this.rol +" "+ this.naam + " heeft (nog) geen kennis over wie mogelijk een onschuldig"
				+ " meisje/ziener is, dus wil daarom de willekeurige burger " + model.spelers.get(keuzeOpeetStem).naam + 
				" verbranden.");

		return keuzeOpeetStem;
	}

	@Override
	//Probeer uit te zoeken welke burgers mogelijkerwijs ziener/onschuldig meisje zijn
	//Doe dit aan de hand van het stemgedrag
	//Hou nu rekening met misleiding: onschuldige meisjes stemmen soms verkeerd dus je kunt burgers niet
	//op basis van een keer stemmen op een burger uitsluiten van een OM te zijn
	public void updateAndereSpelerInschattingen() {
		Iterator<AbstractBurger> it = model.burgers.iterator();
		while (it.hasNext()) {
			AbstractBurger itBurger = (AbstractBurger) it.next();
			if (itBurger.inLeven == true){
				int burgersStem = model.laatsteBrandstapelStemgedrag[itBurger.id];
				//Als een burger correct op een weerwolf heeft gestemd, is het mogelijk meer dan een gewone
				//burger. Als eerder al was uitgesloten dat het een OM is, is het alleen nog mogelijk
				//een ziener.
				if (andereSpelerInschattingen.get(burgersStem).equals("Weerwolf")){
					//Nog mogelijk dat het een OM is
					andereSpelerInschattingen.set(itBurger.id, verhoogdRisicoOpZienerOfOM);
//					System.out.println(this.naam+ ": " + itBurger.id + " verhoogdRisicoOpZienerOfOM!");
				}
				else{
					//Als een burger ooit op een andere burger heeft gestemd, kan de speler van alles zijn 
					//maar heeft in ieder geval geen prioriteit
					andereSpelerInschattingen.set(itBurger.id, burgerOfZienerOfOM);
				}
			}
		}
	}

}
