package spelers.derdeOrde;

import java.util.Iterator;

import simulatie.Model;
import spelers.abstracts.AbstractSpeler;
import spelers.abstracts.AbstractZiener;

public class DrieZiener extends AbstractZiener{

	public DrieZiener(Model controller, String naam, int id) {
		super(controller, naam, id);
		this.orde = derdeOrde;
	}

	@Override
	public void updateAndereSpelerInschattingen() {
		Iterator<AbstractSpeler> it = model.spelers.iterator();
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			String kennisOverItSpeler = andereSpelerInschattingen.get(itSpeler.id);
			
			//bij eerder zekere kennis van kaartkijken, kennis over die speler niet veranderen
			if (kennisOverItSpeler.equals(zekerBurger) | kennisOverItSpeler.equals(zekerBurger) | 
					kennisOverItSpeler.equals(zekerWolf) | kennisOverItSpeler.equals(zekerOM)){
				continue;
			}
			
			if (itSpeler.inLeven == true){
				int spelersStem = model.laatsteBrandstapelStemgedrag[itSpeler.id];
				//Als een speler de vorige keer op een weerwolf heeft gestemd, kan het elke rol zijn, aangezien weerwolven
				//soms ook op andere weerwolven stemmen
				if (model.spelers.get(spelersStem).rol.equals("Weerwolf") | andereSpelerInschattingen.get(itSpeler.id).equals(zekerBurger)){
					andereSpelerInschattingen.set(itSpeler.id, onbekendeRol);
				}
				//Weerwolven zullen meestal nog altijd op burgers stemmen
				//Ook het onschuldig meisje stemt soms op een burger, maar slechts zeer zelden,
				//dus dat is een aanvaardbaar risico
				else{
					andereSpelerInschattingen.set(itSpeler.id, verhoogdRisicoOpWeerwolf);
				}

			}
		}
		//van zichzelf weten ze nog wel wat ze zijn, ook al hebben ze zelf verkeerd gestemd.
		andereSpelerInschattingen.set(this.id, this.rol);
		
	}

}
