package spelers.eersteOrde;

import java.util.Iterator;

import simulatie.Model;
import spelers.abstracts.AbstractBurger;
import spelers.abstracts.AbstractSpeler;
import spelers.abstracts.AbstractZiener;

public class EenZiener extends AbstractZiener{

	public EenZiener(Model controller, String naam, int id) {
		super(controller, naam, id);
		this.orde = eersteOrde;
	}

	@Override
	//Een 1e orde ziener redeneert op dezelfde manier als een 1e orde burger, behalve dat hij niets verandert
	//aan kennis die hij uit kaartkijken heeft ontvangen.
	public void updateAndereSpelerInschattingen() {
		Iterator<AbstractSpeler> it = model.spelers.iterator();
		while (it.hasNext()) {
			AbstractSpeler itSpeler = (AbstractSpeler) it.next();
			String kennisOverItSpeler = andereSpelerInschattingen.get(itSpeler.id);
			
			//bij eerder zekere kennis van kaartkijken, kennis over die speler niet veranderen
			if (kennisOverItSpeler.equals(zekerBurger) | kennisOverItSpeler.equals(zekerBurger) | 
					kennisOverItSpeler.equals(zekerWolf) | kennisOverItSpeler.equals(zekerOM)){
				continue;
			}
			
			if (itSpeler.inLeven == true){
				int spelersStem = model.laatsteBrandstapelStemgedrag[itSpeler.id];
				//Als een speler de vorige keer op een weerwolf heeft gestemd, is het zeker geen weerwolf, dus zeker wel een burger
				if (model.spelers.get(spelersStem).rol.equals("Weerwolf") | kennisOverItSpeler.equals(zekerBurger)){
					andereSpelerInschattingen.set(itSpeler.id, zekerBurger);
//					System.out.println(this.naam + " denkt dat " + itBurger.naam + " zekerBurger is.");
				}
				else{
					andereSpelerInschattingen.set(itSpeler.id, verhoogdRisicoOpWeerwolf);
//					System.out.println(this.naam + " denkt dat " + itBurger.naam + " verhoogdRisicoOpWeerwolf is.");
				}

			}
		}
		//van zichzelf weten ze nog wel wat ze zijn, ook al hebben ze zelf verkeerd gestemd.
		andereSpelerInschattingen.set(this.id, this.rol);
		
	}

}
